//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TMainForm.h"
//---------------------------------------------------------------------------
#pragma link "TDx_Sound"
#pragma link "TDx_SoundBuffer"
#pragma link "TDSCaps"
#pragma link "TDSBufferDesc"
#pragma link "TDx_Sound_Library_Install"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
#define Msg(A) 		StatusMemo->Lines->Add(A)
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
KnownDevices = new TStringList();
KnownModules = new TStringList();
KnownGuids = new TList();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (Dx_Sound1->Created) Dx_Sound1->Destroy();

if (KnownGuids) delete KnownGuids;
if (KnownModules) delete KnownModules;
if (KnownDevices) delete KnownDevices;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EnumerateButtonClick(TObject *Sender)
{
Msg( "Enumerating DirectSound devices..." );

CapsMemo->Lines->Clear();
DevicesListBox->Items->Clear();
if (Dx_Sound1->DSEnumerate( NULL ))
	{
    if (KnownDevices->Count==0)
    	Msg("No available DirectSound devices!");
    }
else
    Msg("No available DirectSound devices!");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxClick(TObject *Sender)
{
if (Dx_Sound1->Created) Dx_Sound1->Destroy();

if (Dx_Sound1->Create( (GUID*) KnownGuids->Items[DevicesListBox->ItemIndex] ))
	ActiveDevice->Caption = KnownDevices->Strings[DevicesListBox->ItemIndex];
else
	ActiveDevice->Caption = "None";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1Create(TObject *Sender)
{
if (Dx_Sound1->GetCaps( DSCaps1 ))
	{
	TStringList* strings = DSCaps1->Flags_Strings();
    if (strings)
    	{
     	CapsMemo->Lines->AddStrings(strings);
        delete strings;
        }
    }
Dx_SoundBuffer1->CreateFromFile("..\\..\\Wav\\Begin.wav", DSBufferDesc1, Dx_Sound1);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1Create(TObject *Sender)
{
Dx_SoundBuffer1->Play(0);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1Destroy(TObject *Sender)
{
CapsMemo->Lines->Clear();
if (Dx_SoundBuffer1->Created) Dx_SoundBuffer1->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1BufferLost(TObject *Sender)
{
Dx_SoundBuffer1->CreateFromFile( "..\\..\\Wav\\Begin.wav", DSBufferDesc1, Dx_Sound1 );
Dx_SoundBuffer1->Play( 0 );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1DSEnumCallback(TObject *Sender, GUID *TheGUID, AnsiString TheDriverDescription, AnsiString TheDriverModule, void *TheContext, bool &Finished)
{
Msg( "In> OnDSEnumCallback(), found device: "+TheDriverDescription );

if (KnownDevices && KnownModules && KnownGuids)
	{
    KnownDevices->Add( TheDriverDescription );
    KnownModules->Add( TheDriverModule );
    KnownGuids->Add( (void*) TheGUID );
    DevicesListBox->Items->Add( TheDriverDescription + ", ("+TheDriverModule+")" );
    }
else
	Finished = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1Error(TObject *Sender,
      AnsiString TheFunction, AnsiString TheError,
      AnsiString TheErrorMessage)
{
Msg( "An error occurred in: "+TheFunction+"..." );
Msg( "... the error code: "+TheError );
Msg( "... the error message: "+TheErrorMessage );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::QuitButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
