//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TMainForm.h"
//---------------------------------------------------------------------------
#pragma link "TDx_Sound"
#pragma link "TDx_SoundBuffer"
#pragma link "TDSCaps"
#pragma link "TDSBufferDesc"
#pragma link "TDx_Sound_Library_Install"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
KnownDevices = new TStringList();
KnownModules = new TStringList();
KnownGuids = new TList();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
DirectoryListBox1->Directory = DirectoryListBox1->Directory + "\\..\\..\\Wav";
DevicesListBox->Items->Clear();
if (Dx_Sound1->DSEnumerate( NULL ))
    if (KnownDevices->Count>0)
    	{
	    DevicesListBox->ItemIndex = 0;
	    Dx_Sound1->Create( (GUID*) KnownGuids->Items[DevicesListBox->ItemIndex] );
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (Dx_Sound1->Created) Dx_Sound1->Destroy();

if (KnownGuids) delete KnownGuids;
if (KnownModules) delete KnownModules;
if (KnownDevices) delete KnownDevices;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxClick(TObject *Sender)
{
if (Dx_Sound1->Created) Dx_Sound1->Destroy();
NotCreatedLabel->Visible = !Dx_Sound1->Create( (GUID*) KnownGuids->Items[DevicesListBox->ItemIndex] );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1Destroy(TObject *Sender)
{
if (Dx_SoundBuffer4->Created) Dx_SoundBuffer4->Destroy();
if (Dx_SoundBuffer3->Created) Dx_SoundBuffer3->Destroy();
if (Dx_SoundBuffer2->Created) Dx_SoundBuffer2->Destroy();
if (Dx_SoundBuffer1->Created) Dx_SoundBuffer1->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1DSEnumCallback(TObject *Sender, GUID *TheGUID, AnsiString TheDriverDescription, AnsiString TheDriverModule, void *TheContext, bool &Finished)
{
if (KnownDevices && KnownModules && KnownGuids)
	{
    KnownDevices->Add( TheDriverDescription );
    KnownModules->Add( TheDriverModule );
    KnownGuids->Add( (void*) TheGUID );
    DevicesListBox->Items->Add( TheDriverDescription + ", ("+TheDriverModule+")" );
    }
else
	Finished = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PlayButtonClick(TObject *Sender)
{
// scan through all selected files
for (int i=0;i<FileListBox1->Items->Count;i++)
    if (FileListBox1->Selected[i])
    	{
        // determine if the file is already created
        bool created = (FileListBox1->Items->Strings[i]==FileNames[0]) ||
        			   (FileListBox1->Items->Strings[i]==FileNames[1]) ||
                       (FileListBox1->Items->Strings[i]==FileNames[2]) ||
                       (FileListBox1->Items->Strings[i]==FileNames[3]);

        if (!created)
        	{
	        // check all 4 buffers and create in first available...
	        if (!Dx_SoundBuffer1->Created)
	            if (Dx_SoundBuffer1->CreateFromFile( FileListBox1->Items->Strings[i], DSBufferDesc1, Dx_Sound1 ))
	            	{
	                FileNames[0] = FileListBox1->Items->Strings[i];
	                if (LoopingCheckBox->Checked) Dx_SoundBuffer1->Play(DSBPLAY_LOOPING);
	                else Dx_SoundBuffer1->Play(0);
                    continue;
	                }

	        if (!Dx_SoundBuffer2->Created)
	            if (Dx_SoundBuffer2->CreateFromFile( FileListBox1->Items->Strings[i], DSBufferDesc2, Dx_Sound1 ))
	            	{
	                FileNames[1] = FileListBox1->Items->Strings[i];
	                if (LoopingCheckBox->Checked) Dx_SoundBuffer2->Play(DSBPLAY_LOOPING);
	                else Dx_SoundBuffer2->Play(0);
                    continue;
	                }

	        if (!Dx_SoundBuffer3->Created)
	            if (Dx_SoundBuffer3->CreateFromFile( FileListBox1->Items->Strings[i], DSBufferDesc3, Dx_Sound1 ))
	            	{
	                FileNames[2] = FileListBox1->Items->Strings[i];
	                if (LoopingCheckBox->Checked) Dx_SoundBuffer3->Play(DSBPLAY_LOOPING);
	                else Dx_SoundBuffer3->Play(0);
                    continue;
	                }

	        if (!Dx_SoundBuffer4->Created)
	            if (Dx_SoundBuffer4->CreateFromFile( FileListBox1->Items->Strings[i], DSBufferDesc4, Dx_Sound1 ))
	            	{
	                FileNames[3] = FileListBox1->Items->Strings[i];
	                if (LoopingCheckBox->Checked) Dx_SoundBuffer4->Play(DSBPLAY_LOOPING);
	                else Dx_SoundBuffer4->Play(0);
	                }
            }
     	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StopButtonClick(TObject *Sender)
{
for (int i=0;i<FileListBox1->Items->Count;i++)
    if (FileListBox1->Selected[i])
    	{
        if (FileListBox1->Items->Strings[i] == FileNames[0]) Dx_SoundBuffer1->Destroy();
        if (FileListBox1->Items->Strings[i] == FileNames[1]) Dx_SoundBuffer2->Destroy();
        if (FileListBox1->Items->Strings[i] == FileNames[2]) Dx_SoundBuffer3->Destroy();
        if (FileListBox1->Items->Strings[i] == FileNames[3]) Dx_SoundBuffer4->Destroy();
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileListBox1DblClick(TObject *Sender)
{
PlayButtonClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
if (!Dx_SoundBuffer1->Playing) Dx_SoundBuffer1->Destroy();
if (!Dx_SoundBuffer2->Playing) Dx_SoundBuffer2->Destroy();
if (!Dx_SoundBuffer3->Playing) Dx_SoundBuffer3->Destroy();
if (!Dx_SoundBuffer4->Playing) Dx_SoundBuffer4->Destroy();

NameMemo->Clear();
SizeMemo->Clear();
StatusMemo->Clear();
PositionMemo->Clear();

// display buffer1 status
if (Dx_SoundBuffer1->Created)
	{
	dword temp_play_pos;
	dword temp_write_pos;
    Dx_SoundBuffer1->GetCurrentPosition( &temp_play_pos, &temp_write_pos);

    NameMemo->Lines->Add( FileNames[0].SubString(1,14) );
    SizeMemo->Lines->Add( IntToStr(DSBufferDesc1->BufferBytes) );
    PositionMemo->Lines->Add( IntToStr(temp_play_pos) );
    if (Dx_SoundBuffer1->Playing) StatusMemo->Lines->Add( "Playing..." ); else StatusMemo->Lines->Add( "Stopped..." );
    }

// display buffer2 status
if (Dx_SoundBuffer2->Created)
	{
	dword temp_play_pos;
	dword temp_write_pos;
    Dx_SoundBuffer2->GetCurrentPosition( &temp_play_pos, &temp_write_pos);

    NameMemo->Lines->Add( FileNames[1].SubString(1,14) );
    SizeMemo->Lines->Add( IntToStr(DSBufferDesc2->BufferBytes) );
    PositionMemo->Lines->Add( IntToStr(temp_play_pos) );
    if (Dx_SoundBuffer2->Playing) StatusMemo->Lines->Add( "Playing..." ); else StatusMemo->Lines->Add( "Stopped..." );
    }

// display buffer3 status
if (Dx_SoundBuffer3->Created)
	{
	dword temp_play_pos;
	dword temp_write_pos;
    Dx_SoundBuffer3->GetCurrentPosition( &temp_play_pos, &temp_write_pos);

    NameMemo->Lines->Add( FileNames[2].SubString(1,14) );
    SizeMemo->Lines->Add( IntToStr(DSBufferDesc3->BufferBytes) );
    PositionMemo->Lines->Add( IntToStr(temp_play_pos) );
    if (Dx_SoundBuffer3->Playing) StatusMemo->Lines->Add( "Playing..." ); else StatusMemo->Lines->Add( "Stopped..." );
    }

// display buffer4 status
if (Dx_SoundBuffer4->Created)
	{
	dword temp_play_pos;
	dword temp_write_pos;
    Dx_SoundBuffer4->GetCurrentPosition( &temp_play_pos, &temp_write_pos);

    NameMemo->Lines->Add( FileNames[3].SubString(1,14) );
    SizeMemo->Lines->Add( IntToStr(DSBufferDesc4->BufferBytes) );
    PositionMemo->Lines->Add( IntToStr(temp_play_pos) );
    if (Dx_SoundBuffer4->Playing) StatusMemo->Lines->Add( "Playing..." ); else StatusMemo->Lines->Add( "Stopped..." );
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::QuitButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1Destroy(TObject *Sender)
{
FileNames[0] = "";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer2Destroy(TObject *Sender)
{
FileNames[1] = "";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer3Destroy(TObject *Sender)
{
FileNames[2] = "";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer4Destroy(TObject *Sender)
{
FileNames[3] = "";
}
//---------------------------------------------------------------------------
