//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TMainForm.h"
//---------------------------------------------------------------------------
#pragma link "TDx_Sound"
#pragma link "TDx_SoundBuffer"
#pragma link "TDSCaps"
#pragma link "TDSBufferDesc"
#pragma link "TDx_Sound_Library_Install"
#pragma link "TDx_SoundNotify"                               
#pragma link "TDSBPositionNotify"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TMainForm *MainForm;
//---------------------------------------------------------------------------
int INDENT = 0;
#define Msg(A) 	try {\
					AnsiString ssss = "";\
                    for (int nnnn=0;nnnn<INDENT*4;nnnn++) ssss = ssss + " ";\
                    ssss = ssss + (A);\
                    if (StatusMemo)\
                        if (StatusMemo->Lines)\
                            {\
                            if (StatusMemo->Lines->Text.Length()>10000) StatusMemo->Lines->Clear();\
							StatusMemo->Lines->Add( ssss );\
                            }\
                    }\
				catch (Exception &E)\
                	{\
                    if (StatusMemo)\
                        if (StatusMemo->Lines)\
                    		StatusMemo->Lines->Clear();\
                    }\
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
KnownDevices = new TStringList();
KnownModules = new TStringList();
KnownGuids = new TList();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
if (KnownGuids) delete KnownGuids;
if (KnownModules) delete KnownModules;
if (KnownDevices) delete KnownDevices;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1Destroy(TObject *Sender)
{
if (Dx_SoundBuffer1->Created) Dx_SoundBuffer1->Destroy();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileListBox1DblClick(TObject *Sender)
{
PlayButtonClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PlayButtonClick(TObject *Sender)
{
Msg(" ");
Msg("<< Play Button was Clicked >>");

INDENT++;

if (Edit1->Text.Pos("*")!=0)
	{
    Msg( "    Cannot play *.WAV" );
    INDENT--;
    return;
    }

if ((Edit1->Text!=LastFileName) || !Dx_SoundBuffer1->Created)
	{
    if (Dx_SoundBuffer1->Created)
    	{
        Msg("Destroying existing buffer...");
        Dx_SoundBuffer1->Destroy();
        }

	Msg("Creating From File( \""+Edit1->Text+"\" ) ...");
	if (Dx_SoundBuffer1->CreateFromFile( Edit1->Text, DSBufferDesc1, Dx_Sound1 ))
        LastFileName = Edit1->Text;
    }
else
    Msg("Restarting \""+LastFileName+"\" ...");

if (Dx_SoundBuffer1->Created)
	{
	if (LoopingCheckBox->Checked)
    	{
        Dx_SoundBuffer1->Play(DSBPLAY_LOOPING);
	    if (Dx_SoundBuffer1->Playing) PlayingLabel->Caption = "Buffer is Looping...";
        }
    else
    	{
        Dx_SoundBuffer1->Play(0);
	    if (Dx_SoundBuffer1->Playing) PlayingLabel->Caption = "Buffer is Playing...";
        }
    }

INDENT--;
Msg("<< Play Button has Finished >>");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1Create(TObject *Sender)
{
Msg("TDx_SoundBuffer was created ok");

INDENT++;

BufferSizeLabel->Caption = "Buffer Size: "+IntToStr(DSBufferDesc1->BufferBytes)+" bytes";

Msg("Creating Buffer Notifications");

int percent = DSBufferDesc1->BufferBytes/100;
DSBPositionNotify1->Offset = 0*percent;
DSBPositionNotify2->Offset = 25*percent;
DSBPositionNotify3->Offset = 50*percent;
DSBPositionNotify4->Offset = 75*percent;
DSBPositionNotify5->Offset = DSBPN_OFFSETSTOP;

if (Dx_SoundNotify1->Create( Dx_SoundBuffer1 ))
    if (Dx_SoundNotify1->SetNotificationPositions( 5, DSBPositionNotify1 ))
        {
        Msg("Notification Positions set ok");
        }
    else
        Msg("Notification Positions not set!");

INDENT--;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundNotify1Create(TObject *Sender)
{
Msg("TDx_SoundNotify was created ok");

INDENT++;

INDENT--;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StopButtonClick(TObject *Sender)
{
Msg("");
Msg("<< Stop Button was Clicked >>");

INDENT++;

if (Dx_SoundBuffer1->Created)
	{
	Msg("About to destroy TDx_SoundBuffer");
    Dx_SoundBuffer1->Destroy();
    }

INDENT--;

Msg("<< Stop Button has Finished >>");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1Destroy(TObject *Sender)
{
Msg("TDx_SoundBuffer is being Destroyed..." );

INDENT++;

if (Dx_SoundBuffer1->Playing)
	{
	Msg("Stopping buffer playback..." );
    Dx_SoundBuffer1->Stop();
    }

if (Dx_SoundNotify1->Created)
	{
	Msg("About to Destroy TDx_SoundNotify");
    Dx_SoundNotify1->Destroy();
    }

INDENT--;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundNotify1Destroy(TObject *Sender)
{
Msg("TDx_SoundNotify is being Destroyed..." );

INDENT++;


INDENT--;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::QuitButtonClick(TObject *Sender)
{
StopButtonClick(Sender);

//Msg("<< QUIT BUTTON WAS CLICKED >>");
Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundNotify1Notify(TObject *Sender, int Value)
{
Msg("");
Msg(">> Inside the TDx_SoundNotify::OnNotify() Event..." );

INDENT++;

// if the Dx_SoundNotify1::LocalNotify property is set to true,
// this event is called with the relevant notification position

// if the Dx_SoundNotify1::LocalNotify property is set to false,
// the relevant DSBPositionNotify[X]::OnNotify() events will be called

switch (Value)
	{
    case 0: NotificationLabel->Caption = "Start Of Buffer"; break;
    case 1:	NotificationLabel->Caption = "25%"; break;
    case 2:	NotificationLabel->Caption = "50%"; break;
    case 3: NotificationLabel->Caption = "75%"; break;
    case 4:	NotificationLabel->Caption = "End Of Buffer"; break;
    }

if (Value!=4)
	{
	BufferPosLabel->Caption = "Last Pos: "+NotificationLabel->Caption;
    }
else
	{
	PlayingLabel->Caption = "Buffer is Stopped...";
    BufferPosLabel->Caption = "Last Pos: DSPN_OFFSETSTOP";
    }

Msg("Handling Notification #"+IntToStr(Value)+" ("+NotificationLabel->Caption+", "+BufferPosLabel->Caption+")" );

if (Value==4) StopButtonClick(this);

INDENT--;
Msg("");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DSBPositionNotify1Notify(TObject *Sender)
{
Msg("");
Msg(">> Inside the DSBPositionNotify1::OnNotify() Event..." );

INDENT++;

NotificationLabel->Caption = "Start Of Buffer";
BufferPosLabel->Caption = "Last Pos: "+IntToStr(DSBPositionNotify1->Offset);
Msg("Handling Notification #1 ("+NotificationLabel->Caption+"), "+BufferPosLabel->Caption+"" );

INDENT--;
Msg("");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DSBPositionNotify2Notify(TObject *Sender)
{
Msg("");
Msg(">> Inside the DSBPositionNotify2::OnNotify() Event..." );

INDENT++;

NotificationLabel->Caption = "25%";
BufferPosLabel->Caption = "Last Pos: "+IntToStr(DSBPositionNotify2->Offset);
Msg("Handling Notification #2 ("+NotificationLabel->Caption+"), "+BufferPosLabel->Caption+"" );

INDENT--;
Msg("");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DSBPositionNotify3Notify(TObject *Sender)
{
Msg("");
Msg(">> Inside the DSBPositionNotify3::OnNotify() Event..." );

INDENT++;

NotificationLabel->Caption = "50%";
BufferPosLabel->Caption = "Last Pos: "+IntToStr(DSBPositionNotify3->Offset);
Msg("Handling Notification #3 ("+NotificationLabel->Caption+"), "+BufferPosLabel->Caption+"" );

INDENT--;
Msg("");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DSBPositionNotify4Notify(TObject *Sender)
{
Msg("");
Msg(">> Inside the DSBPositionNotify4::OnNotify() Event..." );

INDENT++;

NotificationLabel->Caption = "75%";
BufferPosLabel->Caption = "Last Pos: "+IntToStr(DSBPositionNotify4->Offset);
Msg("Handling Notification #4 ("+NotificationLabel->Caption+"), "+BufferPosLabel->Caption+"" );

INDENT--;
Msg("");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DSBPositionNotify5Notify(TObject *Sender)
{
Msg("");
Msg(">> Inside the DSBPositionNotify5::OnNotify() Event..." );

INDENT++;

NotificationLabel->Caption = "End Of Buffer";
BufferPosLabel->Caption = "Last Pos: DSBPN_OFFSETSTOP";
Msg("Handling Notification #5 ("+NotificationLabel->Caption+"), "+BufferPosLabel->Caption+"" );

StopButtonClick(this);

INDENT--;
Msg("");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_Sound1DSEnumCallback(TObject *Sender, GUID *TheGUID, AnsiString TheDriverDescription, AnsiString TheDriverModule, void *TheContext, bool &Finished)
{
if (KnownDevices && KnownModules && KnownGuids)
	{
    KnownDevices->Add( TheDriverDescription );
    KnownModules->Add( TheDriverModule );
    KnownGuids->Add( (void*) TheGUID );
    DevicesListBox->Items->Add( TheDriverDescription + ", ("+TheDriverModule+")" );
    }
else
	Finished = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DevicesListBoxClick(TObject *Sender)
{
if (Dx_Sound1->Created) Dx_Sound1->Destroy();
NotCreatedLabel->Visible = !Dx_Sound1->Create( (GUID*) KnownGuids->Items[DevicesListBox->ItemIndex] );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1Error(TObject *Sender,
	AnsiString TheFunction, AnsiString TheError, AnsiString TheErrorMessage)
{
if (TheError!="Info")
	{
    Msg(TheFunction+" "+TheError+" "+TheErrorMessage);
    }
else Msg(TheErrorMessage);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToggleButtonClick(TObject *Sender)
{
Dx_SoundNotify1->LocalNotify = !Dx_SoundNotify1->LocalNotify;

if (Dx_SoundNotify1->LocalNotify) StatusLabel->Caption = "Events handled by TDx_SoundNotify::OnNotify()";
else StatusLabel->Caption = "Events handled by TDSBPositionNotify::OnNotify()";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClearButtonClick(TObject *Sender)
{
StatusMemo->Lines->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Dx_SoundNotify1Error(TObject *Sender,
	AnsiString TheFunction, AnsiString TheError, AnsiString TheErrorMessage)
{
if (Visible) Msg(TheErrorMessage);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Dx_SoundBuffer1BufferLost(TObject *Sender)
{
//Msg("In>  Dx_SoundBuffer1::OnBufferLost()");
//INDENT++;
//Msg("Dx_SoundBuffer1::OnBufferLost(), creating Dx_SoundBuffer1");
Dx_SoundBuffer1->CreateFromFile( Edit1->Text, DSBufferDesc1, Dx_Sound1 );
//Msg("Dx_SoundBuffer1::OnBufferLost(), playing Dx_SoundBuffer1");
Dx_SoundBuffer1->Play( 0 );
//INDENT--; Msg("Out> Dx_SoundBuffer1::OnBufferLost()");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
DirectoryListBox1->Directory = ExtractFilePath( Application->ExeName ) + "..\\..\\Wav";
DevicesListBox->Items->Clear();
if (Dx_Sound1->DSEnumerate( NULL ))
    if (KnownDevices->Count>0)
    	{
	    DevicesListBox->ItemIndex = 0;
	    Dx_Sound1->Create( (GUID*) KnownGuids->Items[DevicesListBox->ItemIndex] );
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormHide(TObject *Sender)
{
// make sure to destroy component internals before the components are destroyed.
if (Dx_Sound1->Created) Dx_Sound1->Destroy();
}
//---------------------------------------------------------------------------
